#SkIndigo Ruby code is copyright Dale Martens 2009, all rights reserved.

class SkIndigoMaterialPicker

def initialize
	plugins=Sketchup.find_support_file("Plugins\/skindigo")
	cursor_path=File.join(plugins,"dropper.gif")
	@@cursor_id=UI.create_cursor(cursor_path,1,18)
	UI.set_cursor(@@cursor_id)
        
end

def activate
    self.reset(nil)
end

def onSetCursor()
	#p "setting cursor"
	#p @@cursor_id
	cursor = UI.set_cursor(@@cursor_id)
end

def deactivate(view)
    view.invalidate 
end

def onMouseMove(flags, x, y, view)   
	view.invalidate
end

def onLButtonDown(flags, x, y, view)
    ray=view.pickray(x,y)
	ray_vec=ray[1]
	item=Sketchup.active_model.raytest(ray)
	if item
		tree=item[1]
		face=tree.last
		mat=nil
		if tree.length>0
			tree.each {|e|
				this_ents_mat=e.material
				mat=e.material if this_ents_mat!=nil
			}
			if face.class==Sketchup::Face
				back_material=face.back_material
				normal=face.normal
				#p ray_vec.dot(normal)
				if ray_vec.dot(normal)>0.0  #if back face is facing camera
					mat=back_material if back_material!=nil
				end
			end
			if mat!=nil	
				Sketchup.active_model.materials.current=mat
			else
				UI.messagebox("No material assigned to face.")
			end
			self.reset(nil)
		end
	end
	
end


def onCancel(flag, view)
    self.reset(view)
end


# Reset the tool back to its initial state
def reset(view)

Sketchup::set_status_text("Click to sample material from scene", SB_PROMPT) 
if( view )
        view.tooltip = nil
        view.invalidate 
end  
 
end

end # class 


